#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <cstdlib>

using namespace std;

char* Le_Seq_Original();
void Quebra_Seq_Original(int n); // n  o numero de sequencia a gerar
int Compara_Sequencias(char s1[211], char s2[211]);
int Qualidade(char s1[211], char s2[211]); // retorna a qualidade do casamento das sequencias
char* Le_Fragmento(char n[4]); // n  o identificador da sequencia
int Conta_Fragmentos(); //conta o numero de fragmentos gerados
void junction(char s1[211], char s2[211], int position, int qual, int seq, int idContig, int idSeq1, int id_seq2);
int menu();

int main() {
    menu();
}

int menu(){
    int op, sub=0, position, qual1, qual2, qual, une, i, j, idSeq1, idSeq2, qtd=0, comp=0, contig=0; //qtd = numero de fragmentos a comparar
    char id1[4] = {'/0'}, id2[4] = {'/0'};                                    //comp = numero de comparaes para para qtd fragmentos

    printf("1 - Quebrar sequencia original;\n"
           "2 - Comparar sequencias;\n"
           "3 - Contar Fragmentos;\n"
           "4 - Comparar todas as sequencias;\n"
           "5 - Sair.\n\n");

    cin >> op;

    system ("cls");
    switch (op){
        case 1:
            printf("quantos fragmentos?\n");
            cin>>qtd;
            Quebra_Seq_Original(qtd);
            system("cls");
            printf("Sequencia quebrada com sucesso!\n\n %d fragmentos gerados", qtd);
            qtd = 0;
            getch();
            system("cls");
            main();
        break;
        case 2:

            printf("\n\nsequencia: ");
            cin >> id1;
            printf("\n\nsequencia: ");
            cin >> id2;

            system("cls");

            printf("S1: \n%s\n\n", Le_Fragmento(id1));
            printf("S2: \n%s\n\n", Le_Fragmento(id2));
            position = Compara_Sequencias(Le_Fragmento(id1), Le_Fragmento(id2));
            qual = Qualidade(Le_Fragmento(id1), Le_Fragmento(id2));
            if(position>0){
                printf("\n\ncasamento na posicao %d", position);
                printf("\nqualidade do casamento %d", qual);
                printf("\n\nagrupar sequencias?\n1 - SIM\n2 - NAO\n");

                cin >> une;
                system("cls");

                switch(une){
                    case 1:

                        printf("As sequencias foram agrupadas!\n\n");
                        getch();
                        system("cls");
                        main();
                    break;
                    case 2:
                        system("cls");
                        main();
                    break;
                }
            }else{
                printf("\n\nnao houve casamento\n\n");
            }
            getch();
            system("cls");
            main();
        break;

        case 3:
            printf("\nNumero de fragmentos gerados: %d", Conta_Fragmentos());
            getch();
            system("cls");
            main();
        break;
        case 4:
            FILE *P;
            P = fopen("contigs.fasta", "w+");
            if (P == NULL) {
                printf("\nArquivo contigs.fasta nao pode ser aberto.");
                printf("\nUse alguma tecla para finalizar !");
                getch();
            }

            qtd = Conta_Fragmentos();
            for (i=0; i<qtd; i++){//calcula o numero de comparaes a serem feitas
                comp = comp+i;
            }
            for (i=0; i<qtd; i++){
                for (j=i+1; j<qtd; j++){
                    contig++;

                    itoa(i, id1, 10);
                    itoa(j, id2, 10);

                    printf("S%d: \n%s\n\n", i, Le_Fragmento(id1));
                    printf("S%d: \n%s\n\n", j, Le_Fragmento(id2));


                    qual1 = Qualidade(Le_Fragmento(id1), Le_Fragmento(id2));
                    qual2 = Qualidade(Le_Fragmento(id2), Le_Fragmento(id1));

                    if(qual1>qual2){
                        position = Compara_Sequencias(Le_Fragmento(id1), Le_Fragmento(id2));
                        qual = qual1;
                        idSeq1 = i;
                        idSeq2 = j;
                        junction(Le_Fragmento(id1), Le_Fragmento(id2), position, qual, i, contig, idSeq1, idSeq2);//junction (sequencia 1, sequencia 2, posiao do casamento,
                    }else{
                        position = Compara_Sequencias(Le_Fragmento(id2), Le_Fragmento(id1));                                                                                    //          qualidade do casamento, a qual das sequencia a posio se refere,
                        qual = qual2;
                        idSeq1 = j;
                        idSeq2 = i;
                        junction(Le_Fragmento(id2), Le_Fragmento(id1), position, qual, j, contig, idSeq1, idSeq2);//junction (sequencia 1, sequencia 2, posiao do casamento,
                    }                                                                                         //          qualidade do casamento, a qual das sequencia a posio se refere,
                }                                                                                             //          id do contig, id da primeira sequencia, id da segunda sequncia)
            }
            printf("\n\nquantidade de fragmentos: %d\n numero de comparacoes: %d\n\n", qtd, comp);
            getch();
            system("cls");
            main();
        break;
        case 5:
            return EXIT_SUCCESS;
        break;

}
    return(0);
}

char* Le_Seq_Original(){
    FILE *T;
    char Linha[211], ini, *result;
    char* s2 = new char[211];
    int n;

    T = fopen("sequencia.fasta", "r");

    if (T == NULL) {
        printf("\nArquivo sequencia.fasta nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    n=0;
    while (!feof(T))
    {
        ini = fgetc(T); //le o primeiro caracter da linha
        if(ini=='>'){ //verifica se  uma linha de comentrio do formato fasta
            result = fgets(Linha, 211, T);  //ignora a linha de comentario, l at 99 caracteres ou at o '\n'
            ini = fgetc(T); //le o primeiro caracter da proxima linha
            //if (result)  // Se foi possvel ler
               // printf("%s",Linha);
        }
        if(ini=='A'||ini=='G'||ini=='T'||ini=='C'){
            //fputc(ini, S);
            //printf("%d ", n);
            s2[n]=ini;
            //printf("%c \n", seq[n]);
            n++;
        }
    }
    s2[n] = '\0';

    fclose(T);
    return (s2);
}

void Quebra_Seq_Original(int n){
    FILE *P;
    int i, r, t, j;
    char* original = new char[211];
    char ini;
    P = fopen("fragmentos.fasta", "w+");

    srand(time(NULL));//inicializando a semente do rand

    if (P == NULL) {
        printf("\nArquivo fragmentos.fasta nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    strcpy(original, Le_Seq_Original());

    fprintf(P,">S0\n");
    for(i=0;i<n;i++){
        r = rand()%210;
        t = rand()%210;
        if(r>t){
           for(j=t;j<r;j++){
                ini = original[j];
                fputc(ini, P);
            }
        }else{
            for(j=r;j<t;j++){
                ini = original[j];
                fputc(ini, P);
            }
        }
        //printf("\n");
        j=i+1;
        if(j<n){
            fprintf(P,"\n>S%d\n", j);
        }
    }
    fprintf(P,"\n");
    fclose(P);
}

int Conta_Fragmentos(){
    FILE *P;
    char *result, Linha[211];
    int n=0, ini;
    P = fopen("fragmentos.fasta", "r");

    if (P == NULL) {
        printf("\nArquivo fragmentos.fasta nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    while (!feof(P))
    {
        ini = fgetc(P); //le o primeiro caracter da linha
        if(ini=='>'){ //verifica se  uma linha de comentrio do formato fasta
            result = fgets(Linha, 211, P);  //ignora a linha de comentario, l at 99 caracteres ou at o '\n'
            ini = fgetc(P); //le o primeiro caracter da proxima linha
            n++;
        }
    }
    fclose(P);
    return(n);
}

char* Le_Fragmento(char n[4]){
    FILE *P;
    int i=0;
    char* s = new char[211];
    char aux[4] = {'/0'}, ini;

    P = fopen("fragmentos.fasta", "r");
    if (P == NULL) {
        printf("\nArquivo fragmentos.fasta nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    while (!feof(P))
    {
        i=0;
        ini = fgetc(P); //le o primeiro caracter da linha
        if(ini=='>'){ //verifica se  uma linha de comentrio do formato fasta
            ini = fgetc(P); //le o S

            ini = fgetc(P); //le o numero da sequencia
            while(ini!='\n'){
                aux[i] = ini; //recebe o numero da sequencia
                i++;
                ini = fgetc(P);
            }

        }


        i = 0;
        if(strcmp(aux,n)==0){
            ini = fgetc(P);
            s[i] = ini;
            while(ini=='A'||ini=='G'||ini=='T'||ini=='C'){
                ini = fgetc(P);
                i++;
                s[i] = ini;
            }
            s[i] = '\0';
            fclose(P);
            return(s);
        }
    }


}

int Compara_Sequencias(char s1[211], char s2[211]){
    FILE *S;
    int i=0, comp1=0, comp2=0, qual1=0, aux=0, j=0, k=0, l=0, casou1=0;

    S = fopen("saida.fasta", "w+");

    if (S == NULL) {
        printf("\nArquivo saida.txt nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    while(s1[i]!='\0'){
        i++;
        comp1=i;
    }

    i=0;
    while(s2[i]!='\0'){
        i++;
        comp2=i;
    }

    if(comp1>comp2)
        aux=comp1;
    else
        aux=comp2;

    for(i=0;i<aux;i++){//
        k=i;
        j=0;

        while(s2[j]==s1[k]){
            j++;
            k++;
        }
        if((k==comp1)||(k==comp2)||(j==comp1)||(j==comp2)){
            if(j>0){
                qual1=j;
                casou1 = i; //guarda a posio do casamento

                l=0;
                while(l<comp1){
                    fputc(s1[l], S);
                    l++;
                }
                fputc('\n', S);

                l=casou1;
                while(l>0){ //insere - at comear o casamento das cadeias
                    fputc('-', S);
                    l--;
                }

                i=0;
                while(i<comp2){//s1[i]!='/0'
                    fputc(s2[i], S);
                    //ini = fgetc(P);
                    i++;
                }
                fputc('\n', S);
                fclose(S);

                i=aux+1;
                return (casou1);
            }else{
                if(casou1==0){
                    i=aux;
                    return (casou1);
                    //

                }
            }
        }
    }
}

int Qualidade(char s1[211], char s2[211]){
    int i=0, comp1=0, comp2=0, qual1=0, aux=0, j=0, k=0;

    while(s1[i]!='\0'){

        i++;
        comp1=i;
    }

    i=0;
    while(s2[i]!='\0'){

        i++;
        comp2=i;
    }

    if(comp1>comp2)
        aux=comp1;
    else
        aux=comp2;

//----------------------------  verifica se s2 comea dentro de s1  -----------------------------
    for(i=0;i<aux;i++){//
        k=i;
        j=0;

        while(s2[j]==s1[k]){
            j++;
            k++;
        }
        if((k==comp1)||(k==comp2)||(j==comp1)||(j==comp2)){
            if(j>0){
                qual1=j; //guarda o numero de caracteres envolvidos no casamento
                return (qual1);
            }
        }
    }
}

void junction(char s1[211], char s2[211], int position, int qual, int seq, int idContig, int idSeq1, int idSeq2){
    FILE *P;
    int i=0, j=0;
    //char* contig = new char[211];
    char ini;
    P = fopen("contigs.fasta", "a");

    if (P == NULL) {
        printf("\nArquivo contigs.fasta nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    if(position>0){
        if(qual>2){
            fprintf(P,">contig %d (a%d, b%d) P%d S%d Q%d\n", idContig, idSeq1, idSeq2, position, seq, qual);
        }
    }
    fclose(P);
}
