#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <cstdlib>

using namespace std;

char* Le_Seq_Original();
void Quebra_Seq_Original(int n); // n  o numero de sequencia a gerar
int Compara_Sequencias(char s1[211], char s2[211]);
char* Le_Fragmento(char n); // n  o identificador da sequencia
int Conta_Fragmentos();
int menu();

int main() {
    menu();
}

int menu(){
    int op;

    printf("1 - Quebrar sequencia original;\n"
           "2 - Comparar S1 com S2;\n"
           "3 - Comparar S2 com S1;\n"
           "4 - Sair.\n\n");

    cin >> op;

    system ("cls");
    switch (op){
        case 1:
            Quebra_Seq_Original(2);
            printf("Sequencia quebrada com sucesso!");
            getch();
            system("cls");
            main();
        break;
        case 2:
            printf("S1: \n%s\n\n", Le_Fragmento('1'));
            printf("S2: \n%s\n\n", Le_Fragmento('2'));
            Compara_Sequencias(Le_Fragmento('1'), Le_Fragmento('2'));
            getch();
            system("cls");
            main();
        break;
        case 3:
            printf("S1: \n%s\n\n", Le_Fragmento('1'));
            printf("S2: \n%s\n\n", Le_Fragmento('2'));
            Compara_Sequencias(Le_Fragmento('2'), Le_Fragmento('1'));
            getch();
            system("cls");
            main();
        break;
        case 4:
            return EXIT_SUCCESS;
        break;
}
    //printf("\nNumero de Fragmentos: %d\n\n", Conta_Fragmentos());
    return(0);
}

char* Le_Seq_Original(){
    FILE *T;
    char Linha[211], ini, *result;
    char* s2 = new char[211];
    int n;

    T = fopen("sequencia.fasta", "r");

    if (T == NULL) {
        printf("\nArquivo sequencia.fasta nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    n=0;
    while (!feof(T))
    {
        ini = fgetc(T); //le o primeiro caracter da linha
        if(ini=='>'){ //verifica se  uma linha de comentrio do formato fasta
            result = fgets(Linha, 211, T);  //ignora a linha de comentario, l at 99 caracteres ou at o '\n'
            ini = fgetc(T); //le o primeiro caracter da proxima linha
            //if (result)  // Se foi possvel ler
               // printf("%s",Linha);
        }
        if(ini=='A'||ini=='G'||ini=='T'||ini=='C'){
            //fputc(ini, S);
            //printf("%d ", n);
            s2[n]=ini;
            //printf("%c \n", seq[n]);
            n++;
        }
    }
    s2[n] = '\0';

    fclose(T);
    return (s2);
}

void Quebra_Seq_Original(int n){
    FILE *P;
    int i, r, t, j;
    char* original = new char[211];
    char ini;
    P = fopen("fragmentos.fasta", "w+");

    srand(time(NULL));//inicializando a semente do rand

    if (P == NULL) {
        printf("\nArquivo fragmentos.fasta nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    strcpy(original, Le_Seq_Original());

    fprintf(P,">S1\n");
    for(i=0;i<n;i++){
        r = rand()%210;
        t = rand()%210;
        if(r>t){
           for(j=t;j<r;j++){
                ini = original[j];
                fputc(ini, P);
            }
        }else{
            for(j=r;j<t;j++){
                ini = original[j];
                fputc(ini, P);
            }
        }
        //printf("\n");
        j=i+2;
        if(j<=n){
            fprintf(P,"\n>S%d\n", j);
        }
    }
    fprintf(P,"\n");
    fclose(P);
}

int Conta_Fragmentos(){
    FILE *P;
    char *result, Linha[211];
    int n=0, ini;
    P = fopen("fragmentos.fasta", "r");

    if (P == NULL) {
        printf("\nArquivo fragmentos.fasta nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    while (!feof(P))
    {
        ini = fgetc(P); //le o primeiro caracter da linha
        if(ini=='>'){ //verifica se  uma linha de comentrio do formato fasta
            result = fgets(Linha, 211, P);  //ignora a linha de comentario, l at 99 caracteres ou at o '\n'
            ini = fgetc(P); //le o primeiro caracter da proxima linha
            n++;
        }
    }
    fclose(P);
    return(n);
}

char* Le_Fragmento(char n){
    FILE *P;
    int i=0;
    char* s = new char[211];
    char aux, ini;

    P = fopen("fragmentos.fasta", "r");
    if (P == NULL) {
        printf("\nArquivo fragmentos.fasta nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    while (!feof(P))
    {
        ini = fgetc(P); //le o primeiro caracter da linha
        if(ini=='>'){ //verifica se  uma linha de comentrio do formato fasta
            ini = fgetc(P); //le o S
            aux = fgetc(P); //le o numero da sequencia
            ini = fgetc(P); //le o \n
        }

        if(aux==n){
            ini = fgetc(P);
            s[i] = ini;
            while(ini=='A'||ini=='G'||ini=='T'||ini=='C'){
                ini = fgetc(P);
                i++;
                s[i] = ini;
            }
            s[i] = '\0';
        }
    }
    fclose(P);
    return(s);
}

int Compara_Sequencias(char s1[211], char s2[211]){
    FILE *S;
    int i=0, comp1=0, comp2=0, qual1=0, aux, j, k, casou1=0;

    S = fopen("saida.fasta", "w+");

    if (S == NULL) {
        printf("\nArquivo saida.txt nao pode ser aberto.");
        printf("\nUse alguma tecla para finalizar !");
        getch();
    }

    while(s1[i]!='\0')
        i++;
    comp1=i;

    i=0;
    while(s2[i]!='\0')
        i++;
    comp2=i;

    if(comp1>comp2)
        aux=comp1;
    else
        aux=comp2;

//----------------------------  verifica se s2 comea dentro de s1  -----------------------------
    for(i=0;i<aux;i++){//
        k=i;
        j=0;

        while(s2[j]==s1[k]){
            j++;
            k++;
        }
        if((k>=comp1)||(k>=comp2)){
            if(j>0){
                casou1 = i; //guarda a posio do casamento
                printf("\n\ncasamento na posicao %d", i);
                i=aux+1;
                //t = i+m; //numero de caracteres ate o final do casamento
                qual1=j;
                printf("\n\nqualidade do casamento %d", qual1);
            }else{
                if(casou1==0){
                    printf("\n\nnao houve casamento\n\n");
                    i=aux;
                }
            }
        }
    }

    j=0;
    while(j<comp1){
        fputc(s1[j], S);
        j++;
    }
    fputc('\n', S);

    j=casou1;
    while(j>0){ //insere - at comear o casamento das cadeias
        fputc('-', S);
        j--;
    }

    i=0;
    while(i<comp2){//s1[i]!='/0'
        fputc(s2[i], S);
        //ini = fgetc(P);
        i++;
    }
    fputc('\n', S);
    fclose(S);
    return (casou1);

}
